﻿# -*- coding: utf-8 -*-
# (c) 2oo8 by Chrisber
# Version 1.0 27/12/08
# mail@chrisber.de
# http://www.chaos-club.eu
import es, nativeini, usermsg



#
# Information
#
info             = es.AddonInfo()
info.name        = "justAdmins"
info.basename    = "justadmins"
info.version     = "1.0 27/12/08"
info.author      = "Chrisber"
info.url         = "http://www.chaos-club.eu"
info.description = "justAdmins is an addon to play sounds and send messages when an admin joins or leaves the server."
info.tags        = "admins just sound join leave sounds music mp3"



#
# Main functions
#
def load():
	global db, cfg
	db = {}
	cfg = nativeini.parse("cfg/justadmins.ini")
	
	es.ServerVar("justadmins", info.version).makepublic()
	
	if not cfg:
		print "[justAdmins] justAdmins config couldn't be found in 'cfg/justadmins.ini', aborting..."
		es.unload("justadmins")
		
		return
	
	if not cfg["general"]["enabled"]:
		print "[justAdmins] justAdmins was set to be disabled, aborting..."
		es.unload("justadmins")
		
		return
	
	performDownload()
	
	print "[justAdmins] justAdmins was loaded. Have fun!"

def unload():
	es.set("justadmins", 0)
	
	print "[justAdmins] justAdmins was unloaded. Good bye!"



#
# Events
#
def es_map_start(event_var):
	performDownload()

def player_activate(event_var):
	performJustAdmin(event_var["es_steamid"], event_var["es_username"], "connect")

def player_disconnect(event_var):
	performJustAdmin(event_var["networkid"], event_var["es_username"], "leave")



#
# Functions
#
def performDownload():
	if not cfg["general"]["autodownload"]:
		return
	
	for sound in cfg["sounds"]:
		es.stringtable("downloadables", "sound/%s" % cfg["sounds"][sound])

def getValue(key, steamid):
	if key in cfg[steamid]:
		return cfg[steamid][key]
	
	return cfg["defaults"][key]

def performJustAdmin(steamid, username, mode):
	if not steamid in cfg:
		return
	
	sound = getValue("on%s" % mode, steamid)
	
	if not getValue("active", steamid) or not sound:
		return
	
	if sound in cfg["sounds"]:
		es.cexec_all("playgamesound %s" % cfg["sounds"][sound])
	
	message = getValue("%smessage" % mode, steamid).replace("%username%", username)
	
	if getValue("chatmessage", steamid):
		es.msg("#multi", message)
	
	message = message.replace("#green", "").replace("#lightgreen", "").replace("#default", "")
	
	if getValue("topmessage", steamid):
		for player in es.getUseridList():
			es.toptext(player, 5, "#red", message)
	
	if getValue("centermessage", steamid):
		es.centermsg(message)
	
	if getValue("bottommessage", steamid):
		for player in es.getUseridList():
			usermsg.hudhint(player, message)